<template>
	<div class="container-fluid" style="font-size: 18px;">
		<div class="mt-3" v-if="show == 'mostrar'">
        	<div class="mt-2 alert alert-primary" role="alert">
            	<strong>No tiene Roles registrados</strong> 
        	</div>
    	</div>
		<div class="d-sm-flex align-items-center justify-content-between mb-4">
            <h1 class="h3 mb-0 text-gray-800">Administración de Roles</h1>
         </div>
         <div class="row">
         	<div class="col-6">
         		<div class="card shadow mb-4">
                <div class="card-header py-3">
                  <h6 class="m-0 font-weight-bold text-primary">Crear rol</h6>
                </div>
                <form method="POST" v-on:submit.prevent="crearRol">
                <div class="card-body">
                  	<div class="form-group">
                  		<label for="nombre">Nombre:</label>
    					<input type="text" v-model="modeloRol.nombreRol" class="form-control" id="nombre" placeholder="rol">
                  	</div>
                  	<label for="descripcion">Permisos:</label>
                  	<div class="form-group row">
    					<div class="form-check form-check-inline col-12 px-3 py-1 font-italic" v-for="permiso in permisos">
	    						<input class="form-check-input" v-model="modeloRol.give" type="checkbox" v-bind:id="'permiso-'+permiso.id" v-bind:value="permiso.id">
							  	<label class="form-check-label" v-bind:for="'permiso-'+permiso.id">{{permiso.name}}
							  	</label>
						</div> 
                  	</div>
                  	<div class="form-group">
                  		<button type="submit" class="btn btn-primary">Crear rol</button>
                  	</div>
                </div>
                </form>
              </div>
         	</div>
         	<div class="col-6">
         		<div class="card shadow mb-4">
	                <div class="card-header py-3">
	                  <h6 class="m-0 font-weight-bold text-primary">Lista de roles</h6>
	                </div>
	                <div class="card-body">
	                   <table class="table" id="myTable" style="font-size: 14px;">
							<thead class="bg-primary text-white">
								<tr>
								  <th scope="col">#</th>
								  <th scope="col">Rol</th>
								  <th scope="col">Acciones</th>
								</tr>
								</thead>
								<tbody>
								<tr v-for="rol in roles">

								  <th scope="row">{{rol.id}}</th>
								  <td>{{rol.name}}</td>
								  <td class="justify-content-center">
            						<button type="button" class="btn btn-danger btn-sm"  v-bind:value="rol.id" data-toggle="modal" v-bind:data-target="'#eliminar-'+rol.id"><i class="fas fa-trash"></i></button>
								  </td>

								</tr>
							</tbody>
						</table>
	                </div>
	            </div>
	            <div class="row">
	            	<div class="col-12">
	            		<div class="card shadow mb-4">
			                <div class="card-header py-3">
			                  <h6 class="m-0 font-weight-bold text-primary">Asignar Rol</h6>
			                </div>
			                <div class="card-body">
			                <form method="POST" v-on:submit.prevent="asignar">
			                 <div class="form-group row justify-content-center">
			                 	<div class="col-4">
			                 		<select v-model="asignacion.rolbd" class="custom-select">
									  <option selected disabled >Roles</option>
									  <option v-for="rol in roles" v-bind:value="rol.id">{{rol.name}}</option>
									</select>
			                 	</div>
			                 	<div class="col-4">
			                 		<select class="custom-select" v-model="asignacion.userbd">
									  <option selected disabled>Usuario</option>
									  <option v-for="user in users" v-bind:value="user.id">{{user.name}}</option>
									</select>
			                 	</div>
			                 	<div class="col-4">
			                 		<button type="submit" class="btn btn-primary">Asignar</button>
			                 	</div>
			                 </div>
			                 </form>
			                </div>
			            </div>
	            	</div>
	            </div>
         	</div>
         </div>
         <div v-for="rol in roles" class="modal fade bd-example-modal-lg" v-bind:id="'eliminar-'+rol.id" tabindex="-1" role="dialog"
             aria-labelledby="myLargeModalLabel" aria-hidden="true">
          <div class="modal-dialog modal-lg">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title mx-2" id="exampleModalLabel"><strong>Eliminar rol</strong></h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <p>¿Estas seguro que deseas eliminar al clientes {{ rol.name }}?</p>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-danger" data-dismiss="modal">Cancelar</button>
                    <button type="button" class="btn btn-primary" v-on:click="deleteRol(rol)">Eliminar</button>
                </div>
            </div>
          </div>
        </div>
	</div>

	

</template> 
<script>
    export default {
		mounted(){ 
            this.getRoles();
        },
        data(){
            return{
            	users:[],
                roles: [],
                modeloRol:{
                	nombreRol:'',
                	give:[],
                },
                asignacion:{
                	rolbd:'',
                	userbd:'',
                },
                permisos:[],
                show:'',
                message:'',
            }
        },
        methods:{
	        getRoles(){
	            var urlGetRoles = "getroles";
	            axios.get(urlGetRoles).then(response=>{
	            	if(response.data.length == 0){
	            		this.show = 'mostrar';
	            	}else{
	            		this.show = 'ocultar';
	            		this.roles = response.data;
	            	}
	                this.getPermisos();
	                this.getUsers();
	            });
	        },
	        getPermisos(){
	            var urlGetPermisos = "getpermisos";
	            axios.get(urlGetPermisos).then(response=>{
	                this.permisos = response.data;
	            });
	        },
	        getUsers(){
	            var urlGetUsers = "getusers";
	            axios.get(urlGetUsers).then(response=>{
	                this.users = response.data;
	            });
	        },
	        crearRol(){
	        	var urlCreateRol = "administracionroles";
                axios.post(urlCreateRol, this.modeloRol).then(response=>{
                	this.modeloRol={
	                	nombreRol:'',
	                	give:[],
                	};
                    this.message=response.data;
                    this.getRoles();
                }).catch(error =>{
                    this.message = 'información invalida';
                });
	        },
	        deleteRol(rol){
                var urlDeleteRol = "eliminarol";
                axios.post(urlDeleteRol,rol).then(response=>{
                    this.message=response.data;
                    this.showMessage = 'mostrar';
                    this.getRoles();
                    $('#eliminar-'+rol.id).modal('hide');        
                }).catch(error =>{
                    this.message = 'información invalida';
                });
            },
            asignar(){
	        	var urlAsignaRol = "asignarol";
                axios.post(urlAsignaRol, this.asignacion).then(response=>{
                	this.getRoles();
                    this.message=response.data;
                    
                })
	        },
    	}
    }
</script>